
import java.awt.Dimension;

import fr.cnes.genius.chart.GFreeChartXY.GFreeChartXYItem;
import fr.cnes.genius.exception.GException;
import fr.cnes.genius.exception.GIntervalException;
import fr.cnes.genius.lowLevel.GFrame;
import fr.cnes.genius.lowLevel.GPanel;
import fr.cnes.genius.main.GEvent;
import fr.cnes.genius.main.GListener;
import fr.cnes.genius.plots.GPlotDataMadonaReader;
import fr.cnes.genius.plots.GPlotPanel;

/**
 * Testing GPlotPanel
 * @author goesterjf
 *
 */
public class TestForGPlotPanel extends GPanel implements GListener {
	
	private final GPlotPanel plots;
	
	public TestForGPlotPanel() throws GIntervalException {
        plots = new GPlotPanel("EPH", "", "Ephemeris file", 2, true, new GPlotDataMadonaReader(), true);
	}

	public void generic() throws GException {
		put(plots);
	}

	public void display() throws GException {
		generic();
	}
	
    @Override
    public void before(GEvent e) throws GException {
    }

    @Override
    public void after(GEvent e) throws GException {
        
        if ( (e.getFinalSource() == plots.getGFreeChartXY()) && plots.isDisplayingSerie() ) {
            
            final GFreeChartXYItem coordsAbsMain = plots.getPlaneCoordinates(false);
            if ( coordsAbsMain != null ) {
                System.out.println("Absolute main coordinates: "+coordsAbsMain.getStrX()+" / "+coordsAbsMain.getStrY());            
            }
            
            final GFreeChartXYItem coordsAbsMainSecond = plots.getPlaneCoordinates(true);
            if ( coordsAbsMainSecond != null ) {
                System.out.println("Absolute relative coordinates: "+coordsAbsMainSecond.getStrX()+" / "+coordsAbsMainSecond.getStrY());
            }
            
            final GFreeChartXYItem coordsMain = plots.getItemCoordinates();
            if ( coordsMain != null ) {
                System.out.println("Serie: "+coordsMain.getSeriesName());
                System.out.println("Index in the serie: "+coordsMain.getIndex());
                System.out.println("Position: "+coordsMain.getStrX()+" / "+coordsMain.getStrY());
            } else {
                System.out.println("Too far from a point ...");
            }
            
        }
    }
	
	/**
	 * @param args
	 * @throws GIntervalException 
	 */
	public static void main(String[] args) throws GIntervalException {
		TestForGPlotPanel pan = new TestForGPlotPanel();
		GFrame frame = new GFrame("TestForGPlotPanel", pan);	
		frame.setPreferredSize(new Dimension(800, 650));
		frame.display();
	}

}
